<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTemperatureMeasurement ArrayType
 * @subpackage Arrays
 */
class ArrayOfTemperatureMeasurement extends AbstractStructArrayBase
{
    /**
     * The TemperatureMeasurement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TemperatureMeasurement[]
     */
    public $TemperatureMeasurement;
    /**
     * Constructor method for ArrayOfTemperatureMeasurement
     * @uses ArrayOfTemperatureMeasurement::setTemperatureMeasurement()
     * @param \StructType\TemperatureMeasurement[] $temperatureMeasurement
     */
    public function __construct(array $temperatureMeasurement = array())
    {
        $this
            ->setTemperatureMeasurement($temperatureMeasurement);
    }
    /**
     * Get TemperatureMeasurement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TemperatureMeasurement[]|null
     */
    public function getTemperatureMeasurement()
    {
        return isset($this->TemperatureMeasurement) ? $this->TemperatureMeasurement : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTemperatureMeasurement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTemperatureMeasurement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTemperatureMeasurementForArrayConstraintsFromSetTemperatureMeasurement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTemperatureMeasurementTemperatureMeasurementItem) {
            // validation for constraint: itemType
            if (!$arrayOfTemperatureMeasurementTemperatureMeasurementItem instanceof \StructType\TemperatureMeasurement) {
                $invalidValues[] = is_object($arrayOfTemperatureMeasurementTemperatureMeasurementItem) ? get_class($arrayOfTemperatureMeasurementTemperatureMeasurementItem) : sprintf('%s(%s)', gettype($arrayOfTemperatureMeasurementTemperatureMeasurementItem), var_export($arrayOfTemperatureMeasurementTemperatureMeasurementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TemperatureMeasurement property can only contain items of type \StructType\TemperatureMeasurement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TemperatureMeasurement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TemperatureMeasurement[] $temperatureMeasurement
     * @return \ArrayType\ArrayOfTemperatureMeasurement
     */
    public function setTemperatureMeasurement(array $temperatureMeasurement = array())
    {
        // validation for constraint: array
        if ('' !== ($temperatureMeasurementArrayErrorMessage = self::validateTemperatureMeasurementForArrayConstraintsFromSetTemperatureMeasurement($temperatureMeasurement))) {
            throw new \InvalidArgumentException($temperatureMeasurementArrayErrorMessage, __LINE__);
        }
        if (is_null($temperatureMeasurement) || (is_array($temperatureMeasurement) && empty($temperatureMeasurement))) {
            unset($this->TemperatureMeasurement);
        } else {
            $this->TemperatureMeasurement = $temperatureMeasurement;
        }
        return $this;
    }
    /**
     * Add item to TemperatureMeasurement value
     * @throws \InvalidArgumentException
     * @param \StructType\TemperatureMeasurement $item
     * @return \ArrayType\ArrayOfTemperatureMeasurement
     */
    public function addToTemperatureMeasurement(\StructType\TemperatureMeasurement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TemperatureMeasurement) {
            throw new \InvalidArgumentException(sprintf('The TemperatureMeasurement property can only contain items of type \StructType\TemperatureMeasurement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TemperatureMeasurement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TemperatureMeasurement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TemperatureMeasurement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TemperatureMeasurement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TemperatureMeasurement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TemperatureMeasurement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TemperatureMeasurement
     */
    public function getAttributeName()
    {
        return 'TemperatureMeasurement';
    }
}
